
#include "drawemittance.h"
#include "ui_drawemittance.h"
#include <qdebug.h>
#include <qline.h>

DrawEmittance::DrawEmittance(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::DrawEmittance)
{
    ui->setupUi(this);
    drawLabel = new DrawLabel((QWidget *)ui->frame);
    drawLabel->setGeometry(QRect(0, 0, PLOT_WIDTH*2+10, PLOT_HEIGHT*2+10));
    drawLabel -> enableEllipse = false;
    drawLabel -> angle = 0;
    QRect dummy = QRect(0,0,0,0);

    connect(ui->actionQuit, SIGNAL(triggered()),this,SLOT(fileQuit()));
    connect(ui->smallHalfAxis, SIGNAL(sliderMoved(int)),this,SLOT(drawEllipse()));
    connect(ui->bigHalfAxis, SIGNAL(sliderMoved(int)),this,SLOT(drawEllipse()));
    connect(ui->ellipseAngle, SIGNAL(sliderMoved(int)),this,SLOT(drawEllipse()));
    connect(ui->drawButton, SIGNAL(clicked()),this,SLOT(drawLine()));
    connect(ui->clearButton, SIGNAL(clicked()),this,SLOT(clear()));
    connect(ui->enableEllipse, SIGNAL(stateChanged(int)),this,SLOT(enableEllipse(int)));
}

DrawEmittance::~DrawEmittance()
{
    delete ui;
}

void DrawEmittance::fileQuit()
{
    QCoreApplication::quit();
}

void DrawEmittance::drawLine()
{
        double x1,x2,y1,y2;
        x1 = (ui->pos1)->value();
        x2 = (ui->pos2)->value();
        y1 = (ui->angle1)->value()*100;
        y2 = (ui->angle2)->value()*100;
        QLine line((int)x1,(int)y1,(int)x2,(int)y2);
        drawLabel -> draw(line);
        qDebug() << x1 << x2 << y1 << y2 <<endl;

}

void DrawEmittance::drawEllipse()
{
    int a,b,angle;
    a = (ui->bigHalfAxis) -> value();
    b = (ui->smallHalfAxis) -> value();
    angle = (ui->ellipseAngle) -> value();
    drawLabel -> angle = angle;
    QRect rect = QRect(-a,-b,2*a,2*b);
    drawLabel -> ellipseRect = rect;
    drawLabel -> update();
//    qDebug() << a << b << angle <<endl;
}

void DrawEmittance::enableEllipse(int state)
{
    if (state == Qt::Checked)
        drawLabel -> enableEllipse = true;
    else
        drawLabel -> enableEllipse = false;
    drawLabel -> update();
}
void DrawEmittance::clear()
{
    drawLabel -> count = 0;
    drawLabel -> enableEllipse = false;
    (ui ->enableEllipse)->setChecked(false);
    drawLabel -> update();
}
